//Sensor disk with LEDs displaying revolution speed as binary number
//Source & info: www.HomoFaciens.de
//
//Circuit layout:
//Photo sensors to Arduino A4 and A5
//LEDs with 1k serial resistor to pins
//4, 5, 6, 7, 8, 9, 10, 11, 12, 13


int sensor_00 = 0;
int sensor_01 = 0;
int readValue = 0;
int readValueOld = 0;
int LEDvalue = 0;
int timeOld = 0;
int step = 0;


void setup() {
  DDRB |= 0b00111111;
  DDRD |= 0b11110000;
}

void loop() {
  
  sensor_01 = digitalRead(A5);
  sensor_00 = digitalRead(A4);
    
  if(sensor_00 == 0 && sensor_01 == 0){
    if(step == 1){
      readValue--;
    }
    if(step == 3){
      readValue++;
    }
    step = 0;
  }

  if(sensor_00 == 0 && sensor_01 == 1){
    if(step == 2){
      readValue--;
    }
    if(step == 0){
      readValue++;
    }
    step = 1;
  }

  if(sensor_00 == 1 && sensor_01 == 1){
    if(step == 3){
      readValue--;
    }
    if(step == 1){
      readValue++;
    }
    step = 2;
  }

  if(sensor_00 == 1 && sensor_01 == 0){
    if(step == 0){
      readValue--;
    }
    if(step == 2){
      readValue++;
    }
    step = 3;
  }
  
  if(millis() - timeOld > 1000){
      
  
    LEDvalue = readValue - readValueOld;
    
    while(LEDvalue < 0){
      LEDvalue += 1024;
    }
    while(LEDvalue > 1023){
      LEDvalue -= 1024;
    }
    
    if(LEDvalue >= 512){
      PORTB |= 0b00100000;
      LEDvalue -= 512;
    }
    else{
      PORTB &= 0b11011111;
    }
  
    if(LEDvalue >= 256){
      PORTB |= 0b00010000;
      LEDvalue -= 256;
    }
    else{
      PORTB &= 0b11101111;
    }
  
    if(LEDvalue >= 128){
      PORTB |= 0b00001000;
      LEDvalue -= 128;
    }
    else{
      PORTB &= 0b11110111;
    }
  
    if(LEDvalue >= 64){
      PORTB |= 0b00000100;
      LEDvalue -= 64;
    }
    else{
      PORTB &= 0b11111011;
    }
  
    if(LEDvalue >= 32){
      PORTB |= 0b00000010;
      LEDvalue -= 32;
    }
    else{
      PORTB &= 0b11111101;
    }
  
    if(LEDvalue >= 16){
      PORTB |= 0b0000001;
      LEDvalue -= 16;
    }
    else{
      PORTB &= 0b11111110;
    }
  
    if(LEDvalue >= 8){
      PORTD |= 0b10000000;
      LEDvalue -= 8;
    }
    else{
      PORTD &= 0b01111111;
    }
  
    if(LEDvalue >= 4){
      PORTD |= 0b01000000;
      LEDvalue -= 4;
    }
    else{
      PORTD &= 0b10111111;
    }
  
    if(LEDvalue >= 2){
      PORTD |= 0b00100000;
      LEDvalue -= 2;
    }
    else{
      PORTD &= 0b11011111;
    }
  
    if(LEDvalue >= 1){
      PORTD |= 0b00010000;
      LEDvalue -= 1;
    }
    else{
      PORTD &= 0b11101111;
    }
    
    readValueOld = readValue;
    timeOld = millis();
  }//if(millis() - timeOld > 1000)

  

}

